#include <iostream>

using namespace std;

#define CONGRESO 0
#define SENADO 1
#include "elecciones.h"

void votacion20N(void);
void mostrarResultadosCongreso(int);
void mostrarResultadosSenado(int);
void _resultadosCongreso(void);
void _resultadosSenado(void);
int buscarPorNroVotosRecibidos(int, int);
int buscarMaximo(int, int *);
char *buscarMaximoParaAlgunosAlumnos(int);

int main(void) {
int isla, i;    
  votacion20N();
  _resultadosCongreso();
  _resultadosSenado();
  cout << "Partido mas votado = " << partidosCongreso[buscarMaximo(CONGRESO, &isla)] << endl;
  i = buscarMaximo(SENADO, &isla);
  cout << "Senador mas votado de isla " << islas[isla] << " es ";
  switch (isla) {
    case 0: cout << senadoresTenerife[i] << endl;
            break;
    case 1: cout << senadoresGranCanaria[i] << endl;
            break;
    case 2: cout << senadoresLaPalma[i] << endl;
            break;
    case 3: cout << senadoresLaGomera[i] << endl;
            break;
    case 4: cout << senadoresElHierro[i] << endl;
            break;
    case 5: cout << senadoresLanzarote[i] << endl;
            break;
    case 6: cout << senadoresFuerteventura[i] << endl;
            break;
  } /* switch */
  cout << "Partido mas votado " << buscarMaximoParaAlgunosAlumnos(CONGRESO) << endl; 
  cout << "Senador mas votado de isla " << buscarMaximoParaAlgunosAlumnos(SENADO) << endl;
  system("pause");
} /* main */

void mostrarPartidosCongreso(void) {
int i;
  cout << "Partidos posibles:" << endl;
  for (i = 0; i < PARTIDOS_CONGRESO; i++) 
    cout << i << ".- " << partidosCongreso[i] << endl;
} /* mostrarPartidosCongreso */

void mostrarSenadoresIsla(int isla, int tope) {
int i;
  cout << "Senadores posibles:" << endl;
  for (i = 0; i < tope; i++)
    switch (isla) {
       case 0: cout << i << ".- " << senadoresTenerife[i] << endl;
               break;
       case 1: cout << i << ".- " << senadoresGranCanaria[i] << endl;
               break;
       case 2: cout << i << ".- " << senadoresLaPalma[i] << endl;
               break;
       case 3: cout << i << ".- " << senadoresLaGomera[i] << endl;
               break;
       case 4: cout << i << ".- " << senadoresElHierro[i] << endl;
               break;
       case 5: cout << i << ".- " << senadoresLanzarote[i] << endl;
               break;
       case 6: cout << i << ".- " << senadoresFuerteventura[i] << endl;
               break;
     } /* switch */ 
} /* mostrarSenadoresIsla */

int numeroSenadoresIsla(int isla) {
int tope;
   switch (isla) {
     case 0: tope =  CANDIDATOS_SENADO_TENERIFE;
             break;
     case 1: tope =  CANDIDATOS_SENADO_GRANCANARIA;
             break;
     case 2: tope =  CANDIDATOS_SENADO_LAPALMA;
             break;
     case 3: tope =  CANDIDATOS_SENADO_LAGOMERA;
             break;
     case 4: tope =  CANDIDATOS_SENADO_ELHIERRO;
             break;
     case 5: tope =  CANDIDATOS_SENADO_LANZAROTE;
             break;
     case 6: tope =  CANDIDATOS_SENADO_FUERTEVENTURA;
             break;                                                                                                
  }    
  return tope;    
} /* numeroSenadoresIsla */

// Implemente una funcin 'votacion20N()' que solicit el nmero de votos que se van a emitir y cada uno de ellos.
void votacion20N(void) {
// Decidido por islas que Tenerife es 0 y Gran canaria es 1     
int i, j, k, tope_senado, tope_senadores, num_votantes;
   for (i = 0; i < NUMERO_ISLAS; i++) {
     votoActual.isla = i;  
     if (i < 2) // Islas mayores
       tope_senado = 2;
     else // Islas menores
       tope_senado = 1;
     tope_senadores = numeroSenadoresIsla(votoActual.isla);

     do {
       cout << "Indique numero de votantes en " << islas[i] << " (1 - " << CENSO << "): ";
       cin >> num_votantes;
     } while (num_votantes < 0 || num_votantes > CENSO-1);   
     for (j = 0; j < num_votantes; j++) {
       // Congreso  
       mostrarPartidosCongreso();
       do {       
         cout << "Su voto es para?: ";
         cin >> votoActual.congreso;
       } while (votoActual.congreso < 0 || votoActual.congreso > PARTIDOS_CONGRESO-1); 
       (resultadosCongreso[votoActual.isla][votoActual.congreso])++;

       // Senado
       mostrarSenadoresIsla(votoActual.isla, tope_senadores);
       for (k = 0; k < tope_senado; k++)
         do {       
           cout << "Su voto " << k+1 << " es para?: ";
           cin >> votoActual.senado[k];
         } while (votoActual.senado[k] < 0 || votoActual.senado[k] > tope_senadores-1);

       for (k = 0; k < tope_senado; k++)
         switch (votoActual.isla) {
           case 0: (resultadosSenadoTenerife[votoActual.senado[k]])++;
                   break;
           case 1: (resultadosSenadoGranCanaria[votoActual.senado[k]])++;
                   break;
           case 2: (resultadosSenadoLaPalma[votoActual.senado[k]])++;
                   break;
           case 3: (resultadosSenadoLaGomera[votoActual.senado[k]])++;
                   break;
           case 4: (resultadosSenadoElHierro[votoActual.senado[k]])++;
                   break;
           case 5: (resultadosSenadoLanzarote[votoActual.senado[k]])++;
                   break;
           case 6: (resultadosSenadoFuerteventura[votoActual.senado[k]])++;
                   break;                                                                                                
         } /* switch */                
     } /* for */    
   } /* for */    
} /* votacion20N */

/** Desarrolle una funcin 'mostrarResultadosCongreso()' que reciba como parmetro un nmero entero 'partido'. El parmetro
representa el ndice del array 'partidos' donde est almacenado. La funcin ha de mostrar por la consola los resultados en el
congreso asociados al mismo. **/
void mostrarResultadosCongreso(int partido) { 
int i;
  cout << "Resultados para Partido: " << partidosCongreso[partido] << endl;
  for (i = 0; i < NUMERO_ISLAS; i++)
    cout << "Isla: " << islas[i] << " Votos: " << resultadosCongreso[i][partido] << endl;     
} /* mostrarResultadosCongreso */

/** Desarrolle una funcin 'mostrarResultadosSenado()' que reciba como parmetro un nmero entero 'senador'. El parmetro
representa el ndice del array 'senadores' donde est almacenado. La funcin ha de mostrar por la consola los resultados en el
senado asociados al mismo. **/
void mostrarResultadosSenado(int senador, int isla) {
  switch (isla) {
    case 0: cout << "Resultados Senador "<< senadoresTenerife[senador] << " de la isla de " << islas[isla] << " fueron " << resultadosSenadoTenerife[senador] << endl;
            break;
    case 1: cout << "Resultados Senador "<< senadoresGranCanaria[senador] << " de la isla de " << islas[isla] << " fueron " << resultadosSenadoGranCanaria[senador] << endl;
            break;
    case 2: cout << "Resultados Senador "<< senadoresLaPalma[senador] << " de la isla de " << islas[isla] << " fueron " << resultadosSenadoLaPalma[senador] << endl;
            break;
    case 3: cout << "Resultados Senador "<< senadoresLaGomera[senador] << " de la isla de " << islas[isla] << " fueron " << resultadosSenadoLaGomera[senador] << endl;
            break;
    case 4: cout << "Resultados Senador "<< senadoresElHierro[senador] << " de la isla de " << islas[isla] << " fueron " << resultadosSenadoElHierro[senador] << endl;
            break;
    case 5: cout << "Resultados Senador "<< senadoresLanzarote[senador] << " de la isla de " << islas[isla] << " fueron " << resultadosSenadoLanzarote[senador] << endl;
            break;
    case 6: cout << "Resultados Senador "<< senadoresFuerteventura[senador] << " de la isla de " << islas[isla] << " fueron " << resultadosSenadoFuerteventura[senador] << endl;
            break;                                                                                                
  } /* switch */      
} /* mostrarResultadosSenado */

/** Elabore una funcin 'resultadosCongreso()' que muestre los resultados de las elecciones. Para mostrar los datos asociados a un
partido utilizar la funcin 'mostrarResultadosCongreso()'. **/
void _resultadosCongreso(void) {
int i;
  for (i = 0; i < PARTIDOS_CONGRESO; i++) {
    mostrarResultadosCongreso(i);
    system("pause");
  } /* for */   
} /* resultadosCongreso */

/** Elabore una funcin 'resultadosSenado()' que muestre los resultados de las elecciones. Para mostrar los datos asociados a un
senador utilizar la funcin 'mostrarResultadosSenado()'. **/
void _resultadosSenado(void) {
int i, j, tope_senadores;
  for (i = 0; i < NUMERO_ISLAS; i++) {
    tope_senadores = numeroSenadoresIsla(i);  
    for (j = 0; j < tope_senadores; j++)
      mostrarResultadosSenado(j, i);
    system("pause");  
  } /* for */
} /* _resultadosSenado */

int buscarResultadosSenado(int senador, int isla, int nVotos) {
  switch (isla) {
    case 0: return (resultadosSenadoTenerife[senador] > nVotos) ? 1 : 0;
            break;
    case 1: return (resultadosSenadoGranCanaria[senador] > nVotos) ? 1 : 0;
            break;
    case 2: return (resultadosSenadoLaPalma[senador] > nVotos) ? 1 : 0;
            break;
    case 3: return (resultadosSenadoLaGomera[senador] > nVotos) ? 1 : 0;
            break;
    case 4: return (resultadosSenadoElHierro[senador] > nVotos) ? 1 : 0;
            break;
    case 5: return (resultadosSenadoLanzarote[senador] > nVotos) ? 1 : 0;
            break;
    case 6: return (resultadosSenadoFuerteventura[senador] > nVotos) ? 1 : 0;
            break;                                                                                                
  } /* switch */      
} /* buscarResultadosSenado */

/** Construya una funcin 'buscarPorNroVotosRecibidos()' que reciba dos parmetros:
1. la 'camara' que puede ser el Congreso o el Senado.
2. el 'nVotos' que represente una cantidad de votos.
La funcin ha de devolver el nmero de partidos o senadores que ha recibido ms votos que el parmetro 'nVotos'. **/
int buscarPorNroVotosRecibidos(int camara, int nVotos) {
// camara = 0 (congreso). 1 (senado). ver #define
int numObtenidos = 0, nVotosPartido, i, j, tope_senadores;
  if (camara == CONGRESO) {
    for (j = 0; j < PARTIDOS_CONGRESO; j++) {
      nVotosPartido = 0;           
      for (i = 0; i < NUMERO_ISLAS; i++)
        nVotosPartido += resultadosCongreso[i][j];
      if (nVotosPartido > nVotos)
          numObtenidos++;
    } /* for */      
  } /* if */
  else if (camara == SENADO) {
    for (i = 0; i < NUMERO_ISLAS; i++) {
      tope_senadores = numeroSenadoresIsla(i);  
      for (j = 0; j < tope_senadores; j++)
        numObtenidos += buscarResultadosSenado(j, i, nVotos);
    } /* for */           
  } /* else if */
  return numObtenidos;
} /* buscarPorNroVotosRecibidos */

int devolverResultadosSenado(int senador, int isla) {
  switch (isla) {
    case 0: return resultadosSenadoTenerife[senador];
            break;
    case 1: return resultadosSenadoGranCanaria[senador];
            break;
    case 2: return resultadosSenadoLaPalma[senador];
            break;
    case 3: return resultadosSenadoLaGomera[senador];
            break;
    case 4: return resultadosSenadoElHierro[senador];
            break;
    case 5: return resultadosSenadoLanzarote[senador];
            break;
    case 6: return resultadosSenadoFuerteventura[senador];
            break;                                                                                                
  } /* switch */      
} /* buscarResultadosSenado */

/** Elabore una funcin 'buscarMaximo()' que reciba como parmetro la 'camara'. El parmetro puede tomar el valor Congreso o
Senado. La funcin ha de devolver el elemento con mayor nmero de votos recibidos. **/
int buscarMaximo(int camara, int *isla) {
int i, j, nMayorVotos = 0, nVotos, elemMayorNroVotos, tope_senadores;    
  if (camara == CONGRESO) {
    for (j = 0; j < PARTIDOS_CONGRESO; j++) {
      nVotos = 0;           
      for (i = 0; i < NUMERO_ISLAS; i++)
        nVotos += resultadosCongreso[i][j];
      if (nVotos > nMayorVotos) {
        nMayorVotos = nVotos;
        elemMayorNroVotos = j;
      } /* if */    
    } /* for */
  } /* if */
  else if (camara == SENADO) {
    for (i = 0; i < NUMERO_ISLAS; i++) {
      tope_senadores = numeroSenadoresIsla(i);  
      for (j = 0; j < tope_senadores; j++) {
        nVotos = devolverResultadosSenado(j, i);  
        if (nVotos > nMayorVotos) {
          nMayorVotos = nVotos;
          elemMayorNroVotos = j;
          *isla = i;
        } /* if */
      } /* for */
    } /* for */       
  } /* else if */
  return elemMayorNroVotos;
} /* buscarMaximo */

char *buscarMaximoParaAlgunosAlumnos(int camara) {
int i, j, nMayorVotos = 0, nVotos, tope_senadores;
char *elegido;    
  if (camara == CONGRESO) {
    for (j = 0; j < PARTIDOS_CONGRESO; j++) {
      nVotos = 0;           
      for (i = 0; i < NUMERO_ISLAS; i++)
        nVotos += resultadosCongreso[i][j];
      if (nVotos > nMayorVotos) {
        nMayorVotos = nVotos;
        elegido = (char *) partidosCongreso[j];
      } /* if */    
    } /* for */
  } /* if */
  else if (camara == SENADO) {
    for (i = 0; i < NUMERO_ISLAS; i++) {
      tope_senadores = numeroSenadoresIsla(i);  
      for (j = 0; j < tope_senadores; j++) {
        nVotos = devolverResultadosSenado(j, i);  
        if (nVotos > nMayorVotos) {
          nMayorVotos = nVotos;
          switch (i) {
            case 0: elegido = (char *) senadoresTenerife[j];
                    break;
            case 1: elegido = (char *) senadoresGranCanaria[j];
                    break;
            case 2: elegido = (char *) senadoresLaPalma[j];
                    break;
            case 3: elegido = (char *) senadoresLaGomera[j];
                    break;
            case 4: elegido = (char *) senadoresElHierro[j];
                    break;
            case 5: elegido = (char *) senadoresLanzarote[j];
                    break;
            case 6: elegido = (char *) senadoresFuerteventura[j];
                    break;      
                    } /* switch */
        } /* if */
      } /* for */
    } /* for */       
  } /* else if */
  return elegido;
} /* buscarMaximoParaAlgunosAlumnos */
